using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Text;
using System.Windows.Forms;
using Asukaze.CassavaNET.IO;

namespace Asukaze.CassavaNET
{
	/// <summary>
	///  Cassava.NET ̃CtH[ł
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
    #region fUCiϐERXgN^EDispose
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		private System.ComponentModel.Container components = null;
		private Asukaze.CassavaNET.CsvGrid MainGrid;
		private System.Windows.Forms.ToolBar toolBar1;
		private System.Windows.Forms.StatusBar statusBar;
		private System.Windows.Forms.OpenFileDialog dlgOpen;
    private System.Windows.Forms.SaveFileDialog dlgSave;
		private System.Windows.Forms.MainMenu mainMenu;
		private System.Windows.Forms.MenuItem mnFile;
		private System.Windows.Forms.MenuItem mnEdit;
		private System.Windows.Forms.MenuItem mnTable;
		private System.Windows.Forms.MenuItem mnSearch;
		private System.Windows.Forms.MenuItem mnView;
		private System.Windows.Forms.MenuItem mnOption;
		private System.Windows.Forms.MenuItem mnHelp;
		private System.Windows.Forms.MenuItem mnExit;
		private System.Windows.Forms.MenuItem mnAbout;
		private System.Windows.Forms.MenuItem mnLine12;
		private System.Windows.Forms.MenuItem mnOpen;
		private System.Windows.Forms.MenuItem mnNew;
    private System.Windows.Forms.MenuItem mnUndo;
    private System.Windows.Forms.MenuItem mnRedo;
    private System.Windows.Forms.MenuItem mnLine21;
    private System.Windows.Forms.MenuItem mnCut;
    private System.Windows.Forms.MenuItem mnCopy;
    private System.Windows.Forms.MenuItem mnPaste;
    private System.Windows.Forms.MenuItem mnSelectAll;
    private System.Windows.Forms.MenuItem mnLine22;
    private System.Windows.Forms.MenuItem mnModeSelect;
    private System.Windows.Forms.MenuItem mnSelectRow;
    private System.Windows.Forms.MenuItem mnSelectCol;
    private System.Windows.Forms.MenuItem mnModeEdit;
    private System.Windows.Forms.MenuItem mnSaveAs;
    private System.Windows.Forms.MenuItem mnSave;
    private System.Windows.Forms.MenuItem mnLine11;
    private System.Windows.Forms.MenuItem mnReloadCode;
    private System.Windows.Forms.MenuItem mnReloadCodeShiftJIS;
    private System.Windows.Forms.MenuItem mnReloadCodeEUC;
    private System.Windows.Forms.MenuItem mnReloadCodeJIS;
    private System.Windows.Forms.MenuItem mnReloadCodeUnicode;
    private System.Windows.Forms.MenuItem mnReloadCodeUTF8;
    private System.Windows.Forms.MenuItem mnInsRow;
    private System.Windows.Forms.MenuItem mnInsCol;
    private System.Windows.Forms.MenuItem mnCutRow;
    private System.Windows.Forms.MenuItem mnCutCol;
    private System.Windows.Forms.MenuItem mnSaveCode;
    private System.Windows.Forms.MenuItem mnSaveCodeShiftJIS;
    private System.Windows.Forms.MenuItem mnSaveCodeEUC;
    private System.Windows.Forms.MenuItem mnSaveCodeJIS;
    private System.Windows.Forms.MenuItem mnSaveCodeUnicode;
    private System.Windows.Forms.MenuItem mnSaveCodeUTF8;
    private System.Windows.Forms.MenuItem mnLine13;
    private System.Windows.Forms.MenuItem mnSaveCodeCrlf;
    private System.Windows.Forms.MenuItem mnSaveCodeLf;
    private System.Windows.Forms.MenuItem mnSaveCodeCr;

		public MainForm()
		{
			//
			// Windows tH[fUCiT|[gɕKvłB
			//
			InitializeComponent();

			//
			// RXgN^R[h
			//
      mainData = new CassavaU();
      MainGrid.DataSource = mainData;
		}

		/// <summary>
		/// gpĂ郊\[X̌㏈s܂B
		/// </summary>
		protected override void Dispose (bool disposing)
		{
			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

    #endregion

		#region Windows tH[fUCiŐꂽR[h
		/// <summary>
		/// fUCiT|[gɕKvȃ\bhłB̃\bh̓e
		/// R[hGfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
    {
      this.toolBar1 = new System.Windows.Forms.ToolBar();
      this.mainMenu = new System.Windows.Forms.MainMenu();
      this.mnFile = new System.Windows.Forms.MenuItem();
      this.mnNew = new System.Windows.Forms.MenuItem();
      this.mnOpen = new System.Windows.Forms.MenuItem();
      this.mnReloadCode = new System.Windows.Forms.MenuItem();
      this.mnReloadCodeShiftJIS = new System.Windows.Forms.MenuItem();
      this.mnReloadCodeEUC = new System.Windows.Forms.MenuItem();
      this.mnReloadCodeJIS = new System.Windows.Forms.MenuItem();
      this.mnReloadCodeUnicode = new System.Windows.Forms.MenuItem();
      this.mnReloadCodeUTF8 = new System.Windows.Forms.MenuItem();
      this.mnLine11 = new System.Windows.Forms.MenuItem();
      this.mnSave = new System.Windows.Forms.MenuItem();
      this.mnSaveAs = new System.Windows.Forms.MenuItem();
      this.mnSaveCode = new System.Windows.Forms.MenuItem();
      this.mnSaveCodeShiftJIS = new System.Windows.Forms.MenuItem();
      this.mnSaveCodeEUC = new System.Windows.Forms.MenuItem();
      this.mnSaveCodeJIS = new System.Windows.Forms.MenuItem();
      this.mnSaveCodeUnicode = new System.Windows.Forms.MenuItem();
      this.mnSaveCodeUTF8 = new System.Windows.Forms.MenuItem();
      this.mnLine13 = new System.Windows.Forms.MenuItem();
      this.mnSaveCodeCrlf = new System.Windows.Forms.MenuItem();
      this.mnSaveCodeLf = new System.Windows.Forms.MenuItem();
      this.mnSaveCodeCr = new System.Windows.Forms.MenuItem();
      this.mnLine12 = new System.Windows.Forms.MenuItem();
      this.mnExit = new System.Windows.Forms.MenuItem();
      this.mnEdit = new System.Windows.Forms.MenuItem();
      this.mnUndo = new System.Windows.Forms.MenuItem();
      this.mnRedo = new System.Windows.Forms.MenuItem();
      this.mnLine21 = new System.Windows.Forms.MenuItem();
      this.mnCut = new System.Windows.Forms.MenuItem();
      this.mnCopy = new System.Windows.Forms.MenuItem();
      this.mnPaste = new System.Windows.Forms.MenuItem();
      this.mnSelectAll = new System.Windows.Forms.MenuItem();
      this.mnLine22 = new System.Windows.Forms.MenuItem();
      this.mnModeSelect = new System.Windows.Forms.MenuItem();
      this.mnModeEdit = new System.Windows.Forms.MenuItem();
      this.mnSelectRow = new System.Windows.Forms.MenuItem();
      this.mnSelectCol = new System.Windows.Forms.MenuItem();
      this.mnTable = new System.Windows.Forms.MenuItem();
      this.mnInsRow = new System.Windows.Forms.MenuItem();
      this.mnInsCol = new System.Windows.Forms.MenuItem();
      this.mnCutRow = new System.Windows.Forms.MenuItem();
      this.mnCutCol = new System.Windows.Forms.MenuItem();
      this.mnSearch = new System.Windows.Forms.MenuItem();
      this.mnView = new System.Windows.Forms.MenuItem();
      this.mnOption = new System.Windows.Forms.MenuItem();
      this.mnHelp = new System.Windows.Forms.MenuItem();
      this.mnAbout = new System.Windows.Forms.MenuItem();
      this.statusBar = new System.Windows.Forms.StatusBar();
      this.MainGrid = new Asukaze.CassavaNET.CsvGrid();
      this.dlgOpen = new System.Windows.Forms.OpenFileDialog();
      this.dlgSave = new System.Windows.Forms.SaveFileDialog();
      this.SuspendLayout();
      // 
      // toolBar1
      // 
      this.toolBar1.DropDownArrows = true;
      this.toolBar1.Location = new System.Drawing.Point(0, 0);
      this.toolBar1.Name = "toolBar1";
      this.toolBar1.ShowToolTips = true;
      this.toolBar1.Size = new System.Drawing.Size(496, 42);
      this.toolBar1.TabIndex = 0;
      // 
      // mainMenu
      // 
      this.mainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnFile,
            this.mnEdit,
            this.mnTable,
            this.mnSearch,
            this.mnView,
            this.mnOption,
            this.mnHelp});
      // 
      // mnFile
      // 
      this.mnFile.Index = 0;
      this.mnFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnNew,
            this.mnOpen,
            this.mnReloadCode,
            this.mnLine11,
            this.mnSave,
            this.mnSaveAs,
            this.mnSaveCode,
            this.mnLine12,
            this.mnExit});
      this.mnFile.Text = "t@C(&F)";
      this.mnFile.Popup += new System.EventHandler(this.mnFile_Popup);
      // 
      // mnNew
      // 
      this.mnNew.Index = 0;
      this.mnNew.Text = "VK쐬(&N)";
      this.mnNew.Click += new System.EventHandler(this.mnNew_Click);
      // 
      // mnOpen
      // 
      this.mnOpen.Index = 1;
      this.mnOpen.Text = "J(&O)...";
      this.mnOpen.Click += new System.EventHandler(this.mnOpen_Click);
      // 
      // mnReloadCode
      // 
      this.mnReloadCode.Index = 2;
      this.mnReloadCode.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnReloadCodeShiftJIS,
            this.mnReloadCodeEUC,
            this.mnReloadCodeJIS,
            this.mnReloadCodeUnicode,
            this.mnReloadCodeUTF8});
      this.mnReloadCode.Text = "R[hwēǍ(&D)";
      // 
      // mnReloadCodeShiftJIS
      // 
      this.mnReloadCodeShiftJIS.Index = 0;
      this.mnReloadCodeShiftJIS.RadioCheck = true;
      this.mnReloadCodeShiftJIS.Text = "&Shift-JIS";
      this.mnReloadCodeShiftJIS.Click += new System.EventHandler(this.mnReloadCode_Click);
      // 
      // mnReloadCodeEUC
      // 
      this.mnReloadCodeEUC.Index = 1;
      this.mnReloadCodeEUC.RadioCheck = true;
      this.mnReloadCodeEUC.Text = "&EUC";
      this.mnReloadCodeEUC.Click += new System.EventHandler(this.mnReloadCode_Click);
      // 
      // mnReloadCodeJIS
      // 
      this.mnReloadCodeJIS.Index = 2;
      this.mnReloadCodeJIS.RadioCheck = true;
      this.mnReloadCodeJIS.Text = "&JIS";
      this.mnReloadCodeJIS.Click += new System.EventHandler(this.mnReloadCode_Click);
      // 
      // mnReloadCodeUnicode
      // 
      this.mnReloadCodeUnicode.Index = 3;
      this.mnReloadCodeUnicode.RadioCheck = true;
      this.mnReloadCodeUnicode.Text = "&Unicode";
      this.mnReloadCodeUnicode.Click += new System.EventHandler(this.mnReloadCode_Click);
      // 
      // mnReloadCodeUTF8
      // 
      this.mnReloadCodeUTF8.Index = 4;
      this.mnReloadCodeUTF8.RadioCheck = true;
      this.mnReloadCodeUTF8.Text = "UTF-&8";
      this.mnReloadCodeUTF8.Click += new System.EventHandler(this.mnReloadCode_Click);
      // 
      // mnLine11
      // 
      this.mnLine11.Index = 3;
      this.mnLine11.Text = "-";
      // 
      // mnSave
      // 
      this.mnSave.Index = 4;
      this.mnSave.Shortcut = System.Windows.Forms.Shortcut.CtrlS;
      this.mnSave.Text = "㏑ۑ(&S)";
      this.mnSave.Click += new System.EventHandler(this.mnSave_Click);
      // 
      // mnSaveAs
      // 
      this.mnSaveAs.Index = 5;
      this.mnSaveAs.Text = "Otĕۑ(&A)...";
      this.mnSaveAs.Click += new System.EventHandler(this.mnSaveAs_Click);
      // 
      // mnSaveCode
      // 
      this.mnSaveCode.Index = 6;
      this.mnSaveCode.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnSaveCodeShiftJIS,
            this.mnSaveCodeEUC,
            this.mnSaveCodeJIS,
            this.mnSaveCodeUnicode,
            this.mnSaveCodeUTF8,
            this.mnLine13,
            this.mnSaveCodeCrlf,
            this.mnSaveCodeLf,
            this.mnSaveCodeCr});
      this.mnSaveCode.Text = "ۑR[h(&C)";
      // 
      // mnSaveCodeShiftJIS
      // 
      this.mnSaveCodeShiftJIS.Checked = true;
      this.mnSaveCodeShiftJIS.Index = 0;
      this.mnSaveCodeShiftJIS.RadioCheck = true;
      this.mnSaveCodeShiftJIS.Text = "&Shift-JIS";
      this.mnSaveCodeShiftJIS.Click += new System.EventHandler(this.mnSaveCode_Click);
      // 
      // mnSaveCodeEUC
      // 
      this.mnSaveCodeEUC.Index = 1;
      this.mnSaveCodeEUC.RadioCheck = true;
      this.mnSaveCodeEUC.Text = "&EUC";
      this.mnSaveCodeEUC.Click += new System.EventHandler(this.mnSaveCode_Click);
      // 
      // mnSaveCodeJIS
      // 
      this.mnSaveCodeJIS.Index = 2;
      this.mnSaveCodeJIS.RadioCheck = true;
      this.mnSaveCodeJIS.Text = "&JIS";
      this.mnSaveCodeJIS.Click += new System.EventHandler(this.mnSaveCode_Click);
      // 
      // mnSaveCodeUnicode
      // 
      this.mnSaveCodeUnicode.Index = 3;
      this.mnSaveCodeUnicode.RadioCheck = true;
      this.mnSaveCodeUnicode.Text = "&Unicode";
      this.mnSaveCodeUnicode.Click += new System.EventHandler(this.mnSaveCode_Click);
      // 
      // mnSaveCodeUTF8
      // 
      this.mnSaveCodeUTF8.Index = 4;
      this.mnSaveCodeUTF8.RadioCheck = true;
      this.mnSaveCodeUTF8.Text = "UTF-&8";
      this.mnSaveCodeUTF8.Click += new System.EventHandler(this.mnSaveCode_Click);
      // 
      // mnLine13
      // 
      this.mnLine13.Index = 5;
      this.mnLine13.Text = "-";
      // 
      // mnSaveCodeCrlf
      // 
      this.mnSaveCodeCrlf.Checked = true;
      this.mnSaveCodeCrlf.Index = 6;
      this.mnSaveCodeCrlf.RadioCheck = true;
      this.mnSaveCodeCrlf.Text = "CR&+LF";
      this.mnSaveCodeCrlf.Click += new System.EventHandler(this.mnSaveCodeLfcr_Click);
      // 
      // mnSaveCodeLf
      // 
      this.mnSaveCodeLf.Index = 7;
      this.mnSaveCodeLf.RadioCheck = true;
      this.mnSaveCodeLf.Text = "&LF";
      this.mnSaveCodeLf.Click += new System.EventHandler(this.mnSaveCodeLfcr_Click);
      // 
      // mnSaveCodeCr
      // 
      this.mnSaveCodeCr.Index = 8;
      this.mnSaveCodeCr.RadioCheck = true;
      this.mnSaveCodeCr.Text = "&CR";
      this.mnSaveCodeCr.Click += new System.EventHandler(this.mnSaveCodeLfcr_Click);
      // 
      // mnLine12
      // 
      this.mnLine12.Index = 7;
      this.mnLine12.Text = "-";
      // 
      // mnExit
      // 
      this.mnExit.Index = 8;
      this.mnExit.Text = "I(&X)";
      this.mnExit.Click += new System.EventHandler(this.mnExit_Click);
      // 
      // mnEdit
      // 
      this.mnEdit.Index = 1;
      this.mnEdit.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnUndo,
            this.mnRedo,
            this.mnLine21,
            this.mnCut,
            this.mnCopy,
            this.mnPaste,
            this.mnSelectAll,
            this.mnLine22,
            this.mnModeSelect,
            this.mnModeEdit,
            this.mnSelectRow,
            this.mnSelectCol});
      this.mnEdit.Text = "ҏW(&E)";
      // 
      // mnUndo
      // 
      this.mnUndo.Index = 0;
      this.mnUndo.Shortcut = System.Windows.Forms.Shortcut.CtrlZ;
      this.mnUndo.Text = "ɖ߂(&U)";
      this.mnUndo.Click += new System.EventHandler(this.mnUndo_Click);
      // 
      // mnRedo
      // 
      this.mnRedo.Index = 1;
      this.mnRedo.Shortcut = System.Windows.Forms.Shortcut.CtrlY;
      this.mnRedo.Text = "蒼(&Y)";
      this.mnRedo.Click += new System.EventHandler(this.mnRedo_Click);
      // 
      // mnLine21
      // 
      this.mnLine21.Index = 2;
      this.mnLine21.Text = "-";
      // 
      // mnCut
      // 
      this.mnCut.Index = 3;
      this.mnCut.Shortcut = System.Windows.Forms.Shortcut.CtrlX;
      this.mnCut.Text = "؂(&T)";
      this.mnCut.Click += new System.EventHandler(this.mnCut_Click);
      // 
      // mnCopy
      // 
      this.mnCopy.Index = 4;
      this.mnCopy.Shortcut = System.Windows.Forms.Shortcut.CtrlC;
      this.mnCopy.Text = "Rs[(&C)";
      this.mnCopy.Click += new System.EventHandler(this.mnCopy_Click);
      // 
      // mnPaste
      // 
      this.mnPaste.Index = 5;
      this.mnPaste.Shortcut = System.Windows.Forms.Shortcut.CtrlV;
      this.mnPaste.Text = "\t(&P)";
      this.mnPaste.Click += new System.EventHandler(this.mnPaste_Click);
      // 
      // mnSelectAll
      // 
      this.mnSelectAll.Index = 6;
      this.mnSelectAll.Shortcut = System.Windows.Forms.Shortcut.CtrlA;
      this.mnSelectAll.Text = "SđI(&A)";
      this.mnSelectAll.Click += new System.EventHandler(this.mnSelectAll_Click);
      // 
      // mnLine22
      // 
      this.mnLine22.Index = 7;
      this.mnLine22.Text = "-";
      // 
      // mnModeSelect
      // 
      this.mnModeSelect.Index = 8;
      this.mnModeSelect.Text = "I[h(&1)";
      this.mnModeSelect.Click += new System.EventHandler(this.mnModeSelect_Click);
      // 
      // mnModeEdit
      // 
      this.mnModeEdit.Index = 9;
      this.mnModeEdit.Shortcut = System.Windows.Forms.Shortcut.F2;
      this.mnModeEdit.Text = "ҏW[h(&2)";
      this.mnModeEdit.Click += new System.EventHandler(this.mnModeEdit_Click);
      // 
      // mnSelectRow
      // 
      this.mnSelectRow.Index = 10;
      this.mnSelectRow.Text = "sI(&R)";
      this.mnSelectRow.Click += new System.EventHandler(this.mnSelectRow_Click);
      // 
      // mnSelectCol
      // 
      this.mnSelectCol.Index = 11;
      this.mnSelectCol.Text = "I(&L)";
      this.mnSelectCol.Click += new System.EventHandler(this.mnSelectCol_Click);
      // 
      // mnTable
      // 
      this.mnTable.Index = 2;
      this.mnTable.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnInsRow,
            this.mnInsCol,
            this.mnCutRow,
            this.mnCutCol});
      this.mnTable.Text = "}E폜(&T)";
      // 
      // mnInsRow
      // 
      this.mnInsRow.Index = 0;
      this.mnInsRow.Text = "Ps}(&R)";
      this.mnInsRow.Click += new System.EventHandler(this.mnInsRow_Click);
      // 
      // mnInsCol
      // 
      this.mnInsCol.Index = 1;
      this.mnInsCol.Text = "P}(&C)";
      this.mnInsCol.Click += new System.EventHandler(this.mnInsCol_Click);
      // 
      // mnCutRow
      // 
      this.mnCutRow.Index = 2;
      this.mnCutRow.Text = "Ps폜(&D)";
      this.mnCutRow.Click += new System.EventHandler(this.mnCutRow_Click);
      // 
      // mnCutCol
      // 
      this.mnCutCol.Index = 3;
      this.mnCutCol.Text = "P폜(&X)";
      this.mnCutCol.Click += new System.EventHandler(this.mnCutCol_Click);
      // 
      // mnSearch
      // 
      this.mnSearch.Index = 3;
      this.mnSearch.Text = "(&S)";
      // 
      // mnView
      // 
      this.mnView.Index = 4;
      this.mnView.Text = "\(&V)";
      // 
      // mnOption
      // 
      this.mnOption.Index = 5;
      this.mnOption.Text = "IvV(&O)";
      // 
      // mnHelp
      // 
      this.mnHelp.Index = 6;
      this.mnHelp.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnAbout});
      this.mnHelp.Text = "wv(&H)";
      // 
      // mnAbout
      // 
      this.mnAbout.Index = 0;
      this.mnAbout.Text = "o[W(&A)...";
      this.mnAbout.Click += new System.EventHandler(this.mnAbout_Click);
      // 
      // statusBar
      // 
      this.statusBar.Location = new System.Drawing.Point(0, 274);
      this.statusBar.Name = "statusBar";
      this.statusBar.Size = new System.Drawing.Size(496, 16);
      this.statusBar.TabIndex = 1;
      // 
      // MainGrid
      // 
      this.MainGrid.BackColor = System.Drawing.Color.White;
      this.MainGrid.Col = 0;
      this.MainGrid.DataSource = null;
      this.MainGrid.Dock = System.Windows.Forms.DockStyle.Fill;
      this.MainGrid.Location = new System.Drawing.Point(0, 42);
      this.MainGrid.Name = "MainGrid";
      this.MainGrid.Row = 0;
      this.MainGrid.SelBottom = 0;
      this.MainGrid.SelLeft = 0;
      this.MainGrid.SelRight = 0;
      this.MainGrid.SelTop = 0;
      this.MainGrid.Size = new System.Drawing.Size(496, 232);
      this.MainGrid.TabIndex = 3;
      // 
      // dlgOpen
      // 
      this.dlgOpen.DefaultExt = "csv";
      this.dlgOpen.Filter = "CSV t@C (*.csv)|*.csv|ׂẴt@C (*.*)|*.*";
      // 
      // dlgSave
      // 
      this.dlgSave.DefaultExt = "csv";
      this.dlgSave.Filter = "CSV t@C (*.csv)|*.csv|ׂẴt@C (*.*)|*.*";
      // 
      // MainForm
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(7, 16);
      this.ClientSize = new System.Drawing.Size(496, 290);
      this.Controls.Add(this.MainGrid);
      this.Controls.Add(this.statusBar);
      this.Controls.Add(this.toolBar1);
      this.Font = new System.Drawing.Font("MS UI Gothic", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(128)));
      this.Menu = this.mainMenu;
      this.Name = "MainForm";
      this.Text = "Cassava.NET 0.4.9.13 demo";
      this.ResumeLayout(false);
    }
		#endregion

		/// <summary>
		/// AvP[ṼCGg|CgłB
		/// </summary>
		[STAThread]
		static void Main()
		{
			Application.Run(new MainForm());
		}

		// 菑
    private CassavaU mainData;
    private Setting setting = new Setting(new FileFormat("CSV"));

    // Encode
    private static Encoding GetEncoding(string codename){
      string str = codename.Trim().Replace("&","").Replace("_","").Replace("-","").ToUpper();
      if(str == "SHIFTJIS"){ return EncodingJA.ShiftJIS; }
      else if(str == "EUC"){ return EncodingJA.EUC; }
      else if(str == "JIS"){ return EncodingJA.JIS; }
      else if(str == "UNICODE"){ return Encoding.Unicode; }
      else if(str == "UTF8"){ return Encoding.UTF8; }
      else{ return Encoding.GetEncoding(codename); }
    }

    // Open
    private void Open(string FileName, Encoding encoding){
      setting.FileName = FileName;
      setting.SaveEncoding = encoding;
      using(StreamReader sr = new StreamReader(FileName, encoding)){
       	mainData = new CassavaU(CsvReader.Read(sr, setting.FileFormat, out setting.SaveNewLine));
      }
	    MainGrid.DataSource = mainData;
      mnReloadCodeShiftJIS.Checked = encoding.Equals(EncodingJA.ShiftJIS);
      mnReloadCodeEUC.Checked = encoding.Equals(EncodingJA.EUC);
      mnReloadCodeJIS.Checked = encoding.Equals(EncodingJA.JIS);
      mnReloadCodeUnicode.Checked = encoding.Equals(Encoding.Unicode);
      mnReloadCodeUTF8.Checked = encoding.Equals(Encoding.UTF8);
      mnSaveCodeShiftJIS.Checked = encoding.Equals(EncodingJA.ShiftJIS);
      mnSaveCodeEUC.Checked = encoding.Equals(EncodingJA.EUC);
      mnSaveCodeJIS.Checked = encoding.Equals(EncodingJA.JIS);
      mnSaveCodeUnicode.Checked = encoding.Equals(Encoding.Unicode);
      mnSaveCodeUTF8.Checked = encoding.Equals(Encoding.UTF8);
      mnSaveCodeCrlf.Checked = setting.SaveNewLine.Equals("\r\n");
      mnSaveCodeLf.Checked = setting.SaveNewLine.Equals("\n");
      mnSaveCodeCr.Checked = setting.SaveNewLine.Equals("\r");
    }


    // Cxgnh
    private void mnFile_Popup(object sender, System.EventArgs e)
    {
      mnReloadCode.Enabled = setting.FileOpened;
    }

		private void mnNew_Click(object sender, System.EventArgs e)
		{
      mainData = new CassavaU();
      MainGrid.DataSource = mainData;
		}

		private void mnOpen_Click(object sender, System.EventArgs e)
		{
      if(dlgOpen.ShowDialog() == DialogResult.OK) {
        Encoding enc;
        using(FileStream bs = new FileStream(dlgOpen.FileName, FileMode.Open)){
          enc = EncodingJA.Estimate(bs);
        }
        Open(dlgOpen.FileName, enc);
      }
		}

    private void mnReloadCode_Click(object sender, System.EventArgs e)
    {
      Encoding encoding = GetEncoding((sender as MenuItem).Text);
      Open(setting.FileName, encoding);
    }

    private void mnSave_Click(object sender, System.EventArgs e)
    {
      if(setting.FileName == null || setting.FileName == ""){
        mnSaveAs_Click(sender, e);
      }else{
        MainGrid.UpdateEditing();
        using(StreamWriter sw = new StreamWriter(setting.FileName, false, setting.SaveEncoding)){
          sw.NewLine = setting.SaveNewLine;
          CsvWriter.Write(sw, setting.FileFormat, mainData);
        }
      }
    }

    private void mnSaveAs_Click(object sender, System.EventArgs e)
    {
      dlgSave.FileName = setting.FileName;
      if(dlgSave.ShowDialog() == DialogResult.OK) {
        setting.FileName = dlgSave.FileName;
        mnSave_Click(sender, e);
      }
    }

    private void mnSaveCode_Click(object sender, System.EventArgs e)
    {
      mnSaveCodeShiftJIS.Checked = false;
      mnSaveCodeEUC.Checked = false;
      mnSaveCodeJIS.Checked = false;
      mnSaveCodeUnicode.Checked = false;
      mnSaveCodeUTF8.Checked = false;
      MenuItem mi = sender as MenuItem;
      setting.SaveEncoding = GetEncoding(mi.Text);
      mi.Checked = true;
    }

    private void mnSaveCodeLfcr_Click(object sender, System.EventArgs e)
    {
      mnSaveCodeCrlf.Checked = false;
      mnSaveCodeLf.Checked = false;
      mnSaveCodeCr.Checked = false;
      MenuItem mi = sender as MenuItem;
      if(mi == mnSaveCodeCrlf){ setting.SaveNewLine = "\r\n"; }
      else if(mi == mnSaveCodeLf){ setting.SaveNewLine = "\n"; }
      else if(mi == mnSaveCodeCr){ setting.SaveNewLine = "\r"; }
      mi.Checked = true;
    }

		private void mnExit_Click(object sender, System.EventArgs e)
		{
      Close();
		}

    private void UndoRedo(bool redo)
    {
      Range range;
      MainGrid.EndEditing();
      if(redo){
        mainData.Redo(out range);
      }else{
        mainData.Undo(out range);
      }
      if(range != null){
        MainGrid.Select(range);
        if(range.Size == 1){
          MainGrid.BeginEditing();
        }
      }
      MainGrid.Refresh();
    }

    private void mnUndo_Click(object sender, System.EventArgs e)
    {
      UndoRedo(false);
    }

    private void mnRedo_Click(object sender, System.EventArgs e)
    {
      UndoRedo(true);
    }

    private void mnCut_Click(object sender, System.EventArgs e)
    {
      MainGrid.Cut(setting);
    }

    private void mnCopy_Click(object sender, System.EventArgs e)
    {
      MainGrid.Copy(setting);
    }

    private void mnPaste_Click(object sender, System.EventArgs e)
    {
      MainGrid.Paste(setting);
    }

    private void mnSelectAll_Click(object sender, System.EventArgs e)
    {
      MainGrid.SelectAll();
    }

    private void mnModeSelect_Click(object sender, System.EventArgs e)
    {
      MainGrid.EndEditing();
    }

    private void mnModeEdit_Click(object sender, System.EventArgs e)
    {
      MainGrid.BeginEditing();
    }

    private void mnSelectRow_Click(object sender, System.EventArgs e)
    {
      MainGrid.SelectRows(MainGrid.SelTop, MainGrid.SelBottom);
    }

    private void mnSelectCol_Click(object sender, System.EventArgs e)
    {
      MainGrid.SelectCols(MainGrid.SelLeft, MainGrid.SelRight);
    }

    private void mnInsRow_Click(object sender, System.EventArgs e)
    {
      MainGrid.EndEditing();
      mainData.InsertRow(MainGrid.Row);
      MainGrid.Col = 1;
      MainGrid.BeginEditing();
    }

    private void mnInsCol_Click(object sender, System.EventArgs e)
    {
      MainGrid.EndEditing();
      mainData.InsertCol(MainGrid.Col);
      MainGrid.Col++;
      MainGrid.BeginEditing();
    }

    private void mnCutRow_Click(object sender, System.EventArgs e)
    {
      MainGrid.EndEditing();
      mainData.DeleteRow(MainGrid.Row);
      MainGrid.BeginEditing();
    }

    private void mnCutCol_Click(object sender, System.EventArgs e)
    {
      MainGrid.EndEditing();
      mainData.DeleteCol(MainGrid.Col);
      MainGrid.BeginEditing();
    }

		const string AboutMessage = @"Cassava Editor .NET
    Ver.0.4.9.13 demo
    by 
        2004/09/13";

		private void mnAbout_Click(object sender, System.EventArgs e)
		{
			MessageBox.Show(
      	this, AboutMessage, "o[W", MessageBoxButtons.OK);
		}

	}
}
