using System;

namespace Asukaze.CassavaNET
{
	/// <summary>
	///  Cassava APIB
  ///  W 1 x[XȂ̂ɒӁB
	/// </summary>
	public interface ICassava
	{
    void NewTable();
    void NewTable(int cols, int rows);
    string GetCell(int x, int y);
    bool SetCell(int x, int y, string val);
    int GetColCount();
		int GetRowCount();
    void AddCol();
    void AddRow();
    void InsertCol(int x);
    void InsertRow(int y);
    void DeleteCol(int x);
    void DeleteRow(int y);
    int GetColWidth(int x);
    void SetColWidth(int x, int width);
		int GetRowHeight(int y);
		void SetRowHeight(int y, int height);
	}
}

