using System;
using System.Text;
using Asukaze.CassavaNET.IO;

namespace Asukaze.CassavaNET
{
	public class Setting
	{
    public string FileName;
    public FileFormat FileFormat;
    public FileFormat[] RegisteredFileFormats;
    public Encoding SaveEncoding;
    public string SaveNewLine;

    public Setting(){
      this.FileFormat = new FileFormat();
      RegisteredFileFormats = new FileFormat[1];
      RegisteredFileFormats[0] = this.FileFormat;
      SaveEncoding = EncodingJA.ShiftJIS;
      SaveNewLine = "\r\n";
    }

    public Setting(FileFormat format){
      this.FileFormat = format;
      RegisteredFileFormats = new FileFormat[1];
      RegisteredFileFormats[0] = format;
      SaveEncoding = EncodingJA.ShiftJIS;
      SaveNewLine = "\r\n";
    }

    public bool FileOpened{
      get{ return (FileName != null && FileName != ""); }
    }
	}
}
